/*
 * This file is part of fkmines.
 * 
 * fkmines is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * fkmines is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
 * 
 * Copyright 2009, Richard Molitor
 */

#include <error.h>
#include <stdio.h>
#include <stdlib.h>

#include "generate.h"

#define DEFAULT (10)

int main (int argc, char *argv[])
{
  int i,
      mines=DEFAULT,
      lines=DEFAULT,
      cols=DEFAULT;
  short *field;

  for (i=1; i<argc; i++)
    if (argv[i][0] == '-')
      switch (argv[i][1])
      {
        case 'l':
          lines = atoi (argv[++i]);
          break;
        case 'c':
          cols = atoi (argv[++i]);
          break;
        case 'm':
          mines = atoi (argv[++i]);
          break;
        default:
          fprintf (stderr, "Unkown option %s\n", argv[i]);
      }
    else
      fprintf (stderr, "Unknown argument %s\n", argv[i]);

  field = calloc (cols*lines, sizeof(short));

  printf ("Generating %ix%i field with %i mines...\n", cols, lines, mines);
  if (!generate (field, cols, lines, mines))
    error (1, 0, "Generation failed");

  //dump (field, false);
  //putchar ('\n');
  dump (field, true);

  free (field);

  return EXIT_SUCCESS;
}
